package ch.epfl.ppo.collections;

import java.util.Iterator;

public class ListSet<E> implements Set<E> {
    private List<E> list = new LinkedList<>();

    @Override
    public boolean isEmpty() {
        return list.isEmpty();
    }

    @Override
    public int size() {
        return list.size();
    }

    @Override
    public void add(E newElem) {
        if (! contains(newElem))
            list.add(newElem);
    }

    @Override
    public void remove(E elem) {
        Iterator<E> it = list.iterator();
        while (it.hasNext()) {
            if (it.next().equals(elem)) {
                it.remove();
                return;
            }
        }
    }

    @Override
    public boolean contains(E elem) {
        for (E e: list) {
            if (e.equals(elem))
                return true;
        }
        return false;
    }

    @Override
    public Iterator<E> iterator() {
        return list.iterator();
    }
}
