package ch.epfl.ppo.collections;

import java.util.Iterator;

public class SimpleHashSet<E> implements Set<E> {
    private int size;
    private ListSet<E>[] table;

    public SimpleHashSet() {
        @SuppressWarnings("unchecked")
        ListSet<E>[] table = new ListSet[10];
        for (int i = 0; i < table.length; ++i)
            table[i] = new ListSet<>();

        this.size = 0;
        this.table = table;
    }

    @Override
    public boolean isEmpty() {
        return size == 0;
    }

    @Override
    public int size() {
        return size;
    }

    @Override
    public void add(E newElem) {
        ListSet<E> list = listFor(newElem);
        size -= list.size();
        list.add(newElem);
        size += list.size();
    }

    @Override
    public void remove(E elem) {
        ListSet<E> list = listFor(elem);
        size -= list.size();
        list.remove(elem);
        size += list.size();
    }

    @Override
    public boolean contains(E elem) {
        return listFor(elem).contains(elem);
    }

    @Override
    public Iterator<E> iterator() {
        return new SHSIterator<>(table, size);
    }

    private ListSet<E> listFor(E elem) {
        return table[Math.abs(elem.hashCode() % table.length)];
    }

    private static final class SHSIterator<E> implements Iterator<E> {
        private int remaining;

        public SHSIterator(ListSet<E>[] table, int size) {
            this.remaining = size;
        }

        @Override
        public boolean hasNext() {
            // TODO à compléter
            return false;
        }

        @Override
        public E next() {
            // TODO à compléter
            return null;
        }

        @Override
        public void remove() {
            throw new UnsupportedOperationException();
        }
    }
}
